{ config, ... }:

mkIf (elem "emacs-company" config.machine.pkgs) {
  programs.emacs.init.usePackage.company = {
    enable = true;
    diminish = [ "company-mode" ];
    hook = [ "(after-init . global-company-mode)" ];
    bind = { "\t" = "'company-complete-common"; };
    config = ''
      (setq company-idle-delay 0.3
            company-show-numbers t)
    '';
    extraConfig = ''
      :bind (:map company-mode-map
                  ([remap completion-at-point] . company-complete-common)
                  ([remap complete-symbol] . company-complete-common))
    '';
  };
}
